/**
 * 为hexo增加本地检索功能: http://moxfive.xyz/2016/05/31/hexo-local-search/
 * */

// A local search script with the help of [hexo-generator-search](https://github.com/PaicHyperionDev/hexo-generator-search)
// Copyright (C) 2015
// Joseph Pan <http://github.com/wzpan>
// Shuhao Mao <http://github.com/maoshuhao>
// Edited by MOxFIVE <http://github.com/MOxFIVE>
(function () {
  var config = {
    searchId: 'search-query',
    resultId: 'search-result',
    path: '/search.xml'
  }
  var first_url = ''
  var searchFunc = function (path, search_id, content_id) {
    'use strict'
    $.ajax({
      url: path,
      dataType: 'xml',
      success: function (xmlResponse) {
                // get the contents from search data
        var datas = $('entry', xmlResponse).map(function () {
          return {
            title: $('title', this).text(),
            content: $('content', this).text(),
            url: $('url', this).text()
          }
        }).get()
        var $input = document.getElementById(search_id)
        var $resultContent = document.getElementById(content_id)
        $input.addEventListener('input', function () {
          var str = '<ul class=\"search-result-list\">'
          var search_word = this.value.trim()
          var keywords = search_word.toLowerCase().split(/[\s\-]+/)
          var result_length = 0
          $resultContent.innerHTML = ''
          if (this.value.trim().length <= 0) {
            $resultContent.style.display = 'none'
            return
          }
                    // perform local searching
          datas.forEach(function (data) {
            var isMatch = false
            var content_index = []
            var data_title = data.title.trim().toLowerCase()
            var data_content = data.content.trim().replace(/<[^>]+>/g, '').toLowerCase()
            var data_url = data.url
            var index_title = -1
            var index_content = -1
            var first_occur = -1
                        // only match artiles with not empty titles and contents
            if (data_title != '' && data_content != '') {
              keywords.forEach(function (keyword, i) {
                index_title = data_title.indexOf(keyword)
                index_content = data_content.indexOf(keyword)
                if (index_title < 0 && index_content < 0) {
                  isMatch = false
                } else {
                  isMatch = true
                  if (index_content < 0) {
                    index_content = 0
                  }
                  if (i == 0) {
                    first_occur = index_content
                  }
                }
              })
            }
                        // show search results
            if (isMatch) {
              data_url += '?search=' + search_word
              result_length += 1
              if (result_length == 1) {
                first_url = data_url
              }
              str += "<li><a href='" + data_url + "' class='search-result-title'>" + '> ' + data_title + '</a>'
              var content = data.content.trim().replace(/<[^>]+>/g, '')
              if (first_occur >= 0) {
                                // cut out characters
                var start = first_occur - 6
                var end = first_occur + 6
                if (start < 0) {
                  start = 0
                }
                if (start == 0) {
                  end = 10
                }
                if (end > content.length) {
                  end = content.length
                }
                var match_content = content.substr(start, end)
                                // highlight all keywords
                keywords.forEach(function (keyword) {
                  var regS = new RegExp(keyword, 'gi')
                  match_content = match_content.replace(regS, '<em class="search-keyword">' + keyword + '</em>')
                })
                str += '<p class="search-result">' + match_content + '...</p>'
              }
            }
          })
          if (str.indexOf('li') >= 0) {
            $($resultContent).css({
              display: 'block',
              top: $(search_input).position() + $(search_input).outerHeight() + 5
            })
            $resultContent.innerHTML = str
          } else {
            $resultContent.style.display = 'block'
          }
        })
      }
    })
  }

  var search_input = document.querySelector('#' + config.searchId)
  search_input.onfocus = function () {
    var path = '/search.xml'
    searchFunc(path, config.searchId, config.resultId)
  }
    // 确认回车后跳转第一个链接
  search_input.onkeydown = function (e) {
    if (event.keyCode === 13) {
      if (first_url) {
        location.href = first_url
      }
      return false
    } else if (event.keyCode === 27) {
      hide()
    }
  }
  function hide () {
    var $resultContent = document.getElementById(config.resultId)
    $resultContent.style.display = 'none'
  }

    // 页面query中带有search则加入到输入框
  if (location.search) {
    location.search.replace(/(\?|\&)search=(.*?)(&|$)/, function (all, f, word) {
      if (word) {
        search_input.value = word
      }
    })
  }
})()
